# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para yaske
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import re

from core import logger
from core import config
from core.scrapertools import *
from core.item import Item
try: from servers import servertools
except: from core import servertools

__channel__ = "yaske"
__category__ = "F"
__type__ = "generic"
__title__ = "yaske.net"
__language__ = "ES"

host = "http://www.yaske.org"
idiomas = {'aes':'ESPAÑOL','ala':'LATINO','aus':'VOS'}


def isGeneric():
    return True


def get_page(url):
    logger.info("pelisalacarta.yaske get_page")

    return unicode(
        re.sub(
            r"\n|\r|\t|\s{2}|&nbsp;",
            "",
            cache_page(url)
        ),
        "iso-8859-1",
        errors="replace"
    ).encode("utf-8")


def mainlist(item):
    logger.info("pelisalacarta.yaske mainlist")

    return [
        item.clone(
            title = title,
            action = action,
            url = url,
            e = e
        )
        for title, action, url, e
        in [
            ('Últimos Estrenos','fichas',host + "/?page=1","e"),
            ('Selecciona tu categoría favorita','categorias',host,""),
            ('Recién Agregadas','fichas',host + "/?page=1",""),
            ('Buscar...','search',"","")
        ]
    ]


def search(item, texto):
    logger.info("pelisalacarta.yaske search")

    item.url = host + "/buscar/?q=%s&page=1" % texto

    try:
        return fichas(item)
    except:
        import sys
        for line in sys.exc_info():
            logger.error( "%s" % line )
        return []


def categorias(item):
    logger.info("pelisalacarta.yaske categorias")

    data = get_page(item.url)
    if config.get_setting("adult_mode") == "false":
        data = re.sub(r'title="Películas de Eroticas .18"', "", data)

    return [
        item.clone(
            title = title,
            action = "fichas",
            url = url + "?page=1"
        )
        for title, url
        in find_multiple_matches(
            data,
            '<a title="Películas de ([^"]+)" href="([^"]+)"'
        )
    ]


def fichas(item):
    logger.info("pelisalacarta.yaske fichas")

    data = get_page(item.url)
    page = find_single_match(item.url, "(\d+)$")

    patron  = '<div class="box-%speli"><div class="box-%sposter">' % (item.e,item.e)
    patron += '<a href="([^"]+)".*?'
    patron += '<img src="([^"]+)".*?'
    patron += '<div class="([^"]+)">'
    patron += '</div><div class="([^"]+)"></div>'
    patron += '<span>([^<]+)</span>'
    patron += '</a></div></div>'

    return [
        item.clone(
            title = title + " [ " + idiomas[langs] + " ] [ " + quality +" ]",
            action = "findvideos",
            url = url,
            thumbnail = thumbnail,
            fulltitle = title,
            show = title
        )
        for url, thumbnail, quality, langs, title
        in find_multiple_matches(data, patron)
    ] + [
        item.clone(
            title = ">> Página siguiente",
            action = "fichas",
            url = re.sub(r"\d+$", str(int(page) + 1), item.url),
        )
        if 'title="Ultima"' in data and item.e == ""
        else item.clone(
            title = "- Fin de la lista -",
            action = "fichas",
            folder = False
        )
    ]


def findvideos(item):
    logger.info("pelisalacarta.yaske findvideos url=" + item.url)

    data = get_page(item.url)

    return [
        item.clone(
            url = find_single_match(data,':center;"><iframe src="([^"]+)"'),
            action = "play",
            plot = find_single_match(data,'</h3>(.*?)&#\d+;</div>'),
        )
    ]


def play(item):
    logger.info("pelisalacarta.yaske play item.url="+item.url)

    itemlist = servertools.find_video_items(data=item.url)
    for videoitem in itemlist:
        videoitem.title = item.show
        videoitem.fulltitle = item.fulltitle
        videoitem.show = item.show
        videoitem.thumbnail = item.thumbnail
        videoitem.channel = __channel__

    return itemlist
